<?php

namespace App\controleur;
use App\controleur\UtilisateurModele;
use App\controleur\ImageSaver;
use App\config\Validation;

class AdminControleur extends ModerateurControleur
{
    public function __construct()
    {
        global $twig;
        if (!isset($_REQUEST["action"])) {
            $action = NULL;
        } else {
            $action = \App\config\Validation::nettoyerString($_REQUEST["action"]);
        }
        switch ($action) {
            case "supprimerCompte":
                $this->supprimerCompte();
                break;
            case "consulterSignalement":
                $this->consulterSignalement();
                break;
            case "creerEvenement":
                $this->creerEvenement();
                break;
            case "supprimerEvenement":
                $this->supprimerEvenement();
                break;
            case "supprimerOffre":
                $this->supprimerOffre();
                break;
            default:
                parent::__construct();
        }
    }

    protected function supprimerCompte()
    {
        //TODO
    }

    protected function consulterSignalement()
    {
        //TODO
    }

    public function creerEvenement()
    {
        global $twig;

        if (isset($_FILES["image"])) {
            $img = ImageSaver::SaveImage('image');

            if (!Validation::validerEvenement($_POST["titre"], $_POST["description"], $_POST["date"], $_POST["nbPlaceMax"], $img[1])) {
                $mdl = new UtilisateurModele();
                $mdl->ajouterEvenement($_POST["titre"], $_POST["description"], $_POST["date"], $_POST["nbPlaceMax"], $img[1]);

                $this->listerEvenement();
            } else {
                $dVueErreur[] ="Erreur lors de la création de l'évènement";
                echo $twig->render("erreur.html",['dVueErreur' => $dVueErreur]);
            }
        } else {
            echo $twig->render('creerEvenement.html', []);
        }
    }

    public function supprimerEvenement(?array $params)
    {
        $mdl = new UtilisateurModele();
        $mdl->deleteEvenement($params["id"]);

        $this->listerEvenement();
    }

    protected function supprimerOffre()
    {
        //TODO
    }
}
